diff -r 3f1e7d35d0ab -r 821e8eadeaff src/dep/timer.c
--- a/src/dep/timer.c	Tue May 14 17:07:59 2013 -0700
+++ b/src/dep/timer.c	Sun Oct 27 22:49:29 2013 -0700
@@ -1,5 +1,7 @@
 /*-
- * Copyright (c) 2009-2011 George V. Neville-Neil, Steven Kreuzer,
+ * Copyright (c) 2013, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2011-2012 Solarflare Communications Inc
+ * Copyright (c) 2009-2011 George V. Neville-Neil, Steven Kreuzer, 
  *                         Martin Burnicki, Gael Mace, Alexandre Van Kempen
  * Copyright (c) 2005-2008 Kendall Correll, Aidan Williams
  *
@@ -39,6 +41,9 @@
 #include "../ptpd.h"
 
 #define US_TIMER_INTERVAL (62500)
+#ifdef __sun
+volatile hrtime_t timerInited;
+#endif
 volatile unsigned int elapsed;
 
 /*
@@ -54,15 +59,38 @@
 {
 	elapsed++;
 	/* be sure to NOT call DBG in asynchronous handlers! */
+
+#ifdef __sun
+	/*
+	 * Solaris removes the handler once signal is delivered. We
+	 * need to set the handler again.
+	 */
+	signal(SIGALRM, catch_alarm);
+#endif
 }
 
-void 
+/** Strings to help timer related debug messages. */
+char *PTP_timer_dbg_string[] =
+{"PDELAYREQ_INTERVAL_TIMER",
+  "DELAYREQ_INTERVAL_TIMER",
+  "SYNC_INTERVAL_TIMER",
+  "ANNOUNCE_RECEIPT_TIMER",
+  "ANNOUNCE_INTERVAL_TIMER",
+
+  /* non-spec timers */
+  "OPERATOR_MESSAGES_TIMER",
+  "LEAP_SECOND_PENDING_TIMER",
+  "LEAP_SECOND_NOW_TIMER"
+};
+
+void
 initTimer(void)
 {
-	struct itimerval itimer;
 
 	DBG("initTimer\n");
 
+#if !defined(__sun)
+	struct itimerval itimer;
 	signal(SIGALRM, SIG_IGN);
 
 	elapsed = 0;
@@ -71,6 +99,10 @@
 
 	signal(SIGALRM, catch_alarm);
 	setitimer(ITIMER_REAL, &itimer, 0);
+#else
+	timerInited = gethrtime();
+#endif
+
 }
 
 void 
@@ -83,8 +115,18 @@
 	 * latch how many ticks we got since we were last called
 	 * remember that catch_alarm() is totally asynchronous to this timerUpdate()
 	 */
+#ifdef __sun
+	/*
+	 * We want to have the number of 'ticks' (each equal to
+	 * US_TIMER_INTERVAL microseconds) since last call assigned to
+	 * 'delta'.
+	 */
+	delta = (gethrtime() - timerInited)/(US_TIMER_INTERVAL * 1000);
+	timerInited = gethrtime();
+#else
 	delta = elapsed;
 	elapsed = 0;
+#endif
 
 	if (delta <= 0)
 		return;
@@ -100,7 +142,8 @@
 		    <= 0) {
 			itimer[i].left = itimer[i].interval;
 			itimer[i].expire = TRUE;
-			DBG2("TimerUpdate:    Timer %u has now expired.   (Re-armed again with interval %d, left %d)\n", i, itimer[i].interval, itimer[i].left );
+			DBG2("TimerUpdate:    Timer %u(%s) has now expired.   (Re-armed again with interval %d, left %d)\n",
+			    i, PTP_timer_dbg_string[i], itimer[i].interval, itimer[i].left );
 		}
 	}
 
@@ -113,7 +156,8 @@
 		return;
 
 	itimer[index].interval = 0;
-	DBG2("timerStop:      Stopping timer %d.   (New interval: %d; New left: %d)\n", index, itimer[index].left , itimer[index].interval);
+	DBG2("timerStop:      Stopping timer %d(%s).   (New interval: %d; New left: %d)\n",\
+	    index, PTP_timer_dbg_string[index], itimer[index].left , itimer[index].interval);
 }
 
 void 
@@ -156,12 +200,13 @@
 			DBG("Timer would be issued immediatly. Please raise dep/timer.c:US_TIMER_INTERVAL to hold %.2fs\n",
 				interval
 			);
-			
+
 		}
 	}
 	itimer[index].interval = itimer[index].left;
 
-	DBG2("timerStart:     Set timer %d to %f.  New interval: %d; new left: %d\n", index, interval, itimer[index].left , itimer[index].interval);
+	DBG2("timerStart:     Set timer %d(%s) to %f.  New interval: %d; new left: %d\n",\
+	   index, PTP_timer_dbg_string[index], interval, itimer[index].left , itimer[index].interval);
 }
 
 
@@ -173,21 +218,22 @@
  * PTPv1 algorithm was:
  *    ptpClock->R = getRand(&ptpClock->random_seed) % (PTP_DELAY_REQ_INTERVAL - 2) + 2;
  *    R is the number of Syncs to be received, before sending a new request
- * 
- */ 
+ *
+ */
 void timerStart_random(UInteger16 index, float interval, IntervalTimer * itimer)
 {
 	float new_value;
 
 	new_value = getRand() * interval * 2.0;
-	DBG2(" timerStart_random: requested %.2f, got %.2f\n", interval, new_value);
-	
+	DBG2(" timerStart_random: index %d(%s) requested %.2f, got %.2f\n",
+	    index, PTP_timer_dbg_string[index], interval, new_value);
+
 	timerStart(index, new_value, itimer);
 }
 
 
 
-Boolean 
+Boolean
 timerExpired(UInteger16 index, IntervalTimer * itimer)
 {
 	timerUpdate(itimer);
@@ -201,7 +247,28 @@
 	itimer[index].expire = FALSE;
 
 
-	DBG2("timerExpired:   Timer %d expired, taking actions.   current interval: %d; current left: %d\n", index, itimer[index].left , itimer[index].interval);
+	DBG2("timerExpired:   Timer %d(%s) expired, taking actions.   current interval: %d; current left: %d\n",\
+	    index, PTP_timer_dbg_string[index],  itimer[index].left , itimer[index].interval);
 
 	return TRUE;
 }
+
+void timerNow(TimeInternal *time)
+{
+#if defined(__APPLE__)
+  struct timeval tv;
+
+  gettimeofday(&tv, 0);
+  time->seconds = tv.tv_sec;
+  time->nanoseconds = tv.tv_usec*1000;
+#else
+  struct timespec tv;
+  int err = clock_gettime(CLOCK_REALTIME, &tv);
+  if (err != 0) {
+    ERROR("error getting time %d\n", err);
+    return;
+  }
+  time->seconds = tv.tv_sec;
+  time->nanoseconds = tv.tv_nsec;
+#endif
+}
diff -r 3f1e7d35d0ab -r 821e8eadeaff src/display.c
--- a/src/display.c	Tue May 14 17:07:59 2013 -0700
+++ b/src/display.c	Sun Oct 27 22:49:29 2013 -0700
@@ -1,4 +1,6 @@
 /*-
+ * Copyright (c) 2013, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2011-2012 Solarflare Communications Inc
  * Copyright (c) 2009-2011 George V. Neville-Neil, Steven Kreuzer, 
  *                         Martin Burnicki, Gael Mace, Alexandre Van Kempen
  * Copyright (c) 2005-2008 Kendall Correll, Aidan Williams
@@ -105,7 +107,7 @@
 netPath_display(NetPath * net)
 {
 	struct in_addr addr;
-
+	DBGV(">>>Network Info:\n");
 	DBGV("eventSock : %d \n", net->eventSock);
 	DBGV("generalSock : %d \n", net->generalSock);
 	addr.s_addr = net->multicastAddr;
@@ -114,6 +116,7 @@
 	DBGV("peerMulticastAddress : %s \n", inet_ntoa(addr));
 	addr.s_addr = net->unicastAddr;
 	DBGV("unicastAddress : %s \n", inet_ntoa(addr));
+	DBGV("<<<\n");
 }
 
 /**\brief Display a IntervalTimer Structure*/
@@ -201,27 +204,27 @@
 void 
 msgHeader_display(MsgHeader * header)
 {
-	DBGV("Message header : \n");
+	DBGV(">>>Message header : \n");
 	DBGV("\n");
-	DBGV("transportSpecific : %d\n", header->transportSpecific);
-	DBGV("messageType : %d\n", header->messageType);
-	DBGV("versionPTP : %d\n", header->versionPTP);
-	DBGV("messageLength : %d\n", header->messageLength);
-	DBGV("domainNumber : %d\n", header->domainNumber);
-	DBGV("FlagField %02hhx:%02hhx\n", header->flagField[0], header->flagField[1]);
+	DBGV("\ttransportSpecific : %d\n", header->transportSpecific);
+	DBGV("\tmessageType : %d\n", header->messageType);
+	DBGV("\tversionPTP : %d\n", header->versionPTP);
+	DBGV("\tmessageLength : %d\n", header->messageLength);
+	DBGV("\tdomainNumber : %d\n", header->domainNumber);
+	DBGV("\tFlagField %02hhx:%02hhx\n", header->flagField[0], header->flagField[1]);
 	integer64_display(&header->correctionfield);
 	portIdentity_display(&header->sourcePortIdentity);
-	DBGV("sequenceId : %d\n", header->sequenceId);
-	DBGV("controlField : %d\n", header->controlField);
-	DBGV("logMessageInterval : %d\n", header->logMessageInterval);
-	DBGV("\n");
+	DBGV("\tsequenceId : %d\n", header->sequenceId);
+	DBGV("\tcontrolField : %d\n", header->controlField);
+	DBGV("\tlogMessageInterval : %d\n", header->logMessageInterval);
+	DBGV("<<<\n");
 }
 
 /**\brief Display Announce message*/
 void 
 msgAnnounce_display(MsgAnnounce * announce)
 {
-	DBGV("Announce Message : \n");
+	DBGV(">>>Announce Message : \n");
 	DBGV("\n");
 	DBGV("originTimestamp : \n");
 	DBGV("secondField  : \n");
@@ -235,7 +238,7 @@
 	clockIdentity_display(announce->grandmasterIdentity);
 	DBGV("stepsRemoved : %d \n", announce->stepsRemoved);
 	DBGV("timeSource : %d \n", announce->timeSource);
-	DBGV("\n");
+	DBGV("<<<\n");
 }
 
 /**\brief Display Follow_UP message*/
@@ -292,8 +295,8 @@
 
 	DBGV("---Run time Options Display-- \n");
 	DBGV("\n");
-	DBGV("announceInterval : %d \n", rtOpts->announceInterval);
-	DBGV("syncInterval : %d \n", rtOpts->syncInterval);
+	DBGV("announceInterval : %Lf \n", rtOpts->announceInterval);
+	DBGV("syncInterval : %Lf \n", rtOpts->syncInterval);
 	clockQuality_display(&(rtOpts->clockQuality));
 	DBGV("priority1 : %d \n", rtOpts->priority1);
 	DBGV("priority2 : %d \n", rtOpts->priority2);
@@ -314,7 +317,7 @@
 	timeInternal_display(&(rtOpts->outboundLatency));
 	DBGV("max_foreign_records : %d \n", rtOpts->max_foreign_records);
 	DBGV("ethernet mode : %d \n", rtOpts->ethernet_mode);
-	DBGV("\n");
+	DBGV("--- ---\n");
 }
 
 
@@ -333,7 +336,7 @@
 	DBGV("priority2 : %d \n", ptpClock->priority2);
 	DBGV("domainNumber : %d \n", ptpClock->domainNumber);
 	DBGV("slaveOnly : %d \n", ptpClock->slaveOnly);
-	DBGV("\n");
+	DBGV("-------\n");
 }
 
 
@@ -350,7 +353,7 @@
 	timeInternal_display(&ptpClock->offsetFromMaster);
 	DBGV("Mean path delay : \n");
 	timeInternal_display(&ptpClock->meanPathDelay);
-	DBGV("\n");
+	DBGV("---------\n");
 }
 
 
@@ -371,7 +374,7 @@
 	clockQuality_display(&ptpClock->grandmasterClockQuality);
 	DBGV("grandmasterpriority1 : %d \n", ptpClock->grandmasterPriority1);
 	DBGV("grandmasterpriority2 : %d \n", ptpClock->grandmasterPriority2);
-	DBGV("\n");
+	DBGV("---------\n");
 }
 
 /**\brief Display Global data set of a PtpClock*/
@@ -390,7 +393,7 @@
 	DBGV("frequencyTraceable : %d \n", ptpClock->frequencyTraceable);
 	DBGV("ptpTimescale : %d \n", ptpClock->ptpTimescale);
 	DBGV("timeSource : %d \n", ptpClock->timeSource);
-	DBGV("\n");
+	DBGV("------\n");
 }
 
 /**\brief Display Port data set of a PtpClock*/
@@ -403,6 +406,7 @@
 
 	portIdentity_display(&ptpClock->portIdentity);
 	DBGV("port state : %d \n", ptpClock->portState);
+	DBGV("minDelayReqInterval : %Lf \n", ptpClock->minDelayReqInterval);
 	DBGV("logMinDelayReqInterval : %d \n", ptpClock->logMinDelayReqInterval);
 	DBGV("peerMeanPathDelay : \n");
 	timeInternal_display(&ptpClock->peerMeanPathDelay);
@@ -412,7 +416,7 @@
 	DBGV("delayMechanism : %d \n", ptpClock->delayMechanism);
 	DBGV("logMinPdelayReqInterval : %d \n", ptpClock->logMinPdelayReqInterval);
 	DBGV("versionNumber : %d \n", ptpClock->versionNumber);
-	DBGV("\n");
+	DBGV("--------\n");
 }
 
 /**\brief Display ForeignMaster data set of a PtpClock*/
@@ -444,7 +448,7 @@
 		DBGV("No Foreign masters recorded \n");
 	}
 
-	DBGV("\n");
+	DBGV("---- End of Ptp Clock Foreign Data Set ---\n");
 
 
 }
@@ -506,7 +510,7 @@
 	DBGV("y : %d \n", ptpClock->owd_filt.y);
 	DBGV("s_exp : %d \n", ptpClock->owd_filt.s_exp);
 	DBGV("\n");
-	DBGV("observed_drift : %d \n", ptpClock->observed_drift);
+	DBGV("observed_drift : %Lf \n", ptpClock->observed_drift);
 	DBGV("message activity %d \n", ptpClock->message_activity);
 	DBGV("\n");
 
@@ -519,7 +523,7 @@
 	netPath_display(&ptpClock->netPath);
 	DBGV("mCommunication technology %d \n", ptpClock->port_communication_technology);
 	clockUUID_display(ptpClock->port_uuid_field);
-	DBGV("\n");
+	DBGV("---------\n");
 }
 
 
